#include <_Custom_Charts/Enums.mqh>
#include <_Custom_Charts/Indicadores/Indicadores.mqh>

class NsVPR : public Indicadores {
private:
    double MaxMes[];
    double MaxSem[];
    double MaxDia[];
    double Meio[];
    double MinDia[];
    double MinSem[];
    double MinMes[];

public:
    NsVPR(){};
    ~NsVPR(){};

    //Definição padrão do indicador
    virtual void set();
    //Definição padrão do indicador
    void set(double variacaoPercentil_, int atrasoVelas_);
    //Atualização dos buffers copiando um certo número de posições
    virtual void updateBuffers(int qtdPosCopiadas);
    //Atualização dos buffers
    virtual void updateBuffers();
    //Retorno de um valor do buffer em uma posição
    virtual double getBufferValue(int bufferEnum, int bufferPos);
    //O valor do buffer no candle atual
    virtual double getBufferLast(int bufferEnum);
};

void NsVPR::set(){
    this.set(0, 5);
}

void NsVPR::set(double variacaoPercentil_, int atrasoVelas_){
    this.setManipulador(iCustom(_Symbol, _Period, "NsVPR", variacaoPercentil_, atrasoVelas_));
}

void NsVPR::updateBuffers(int qtdPosCopiadas){
    int manipuladorLocal = this.getManipulador();
    if(manipuladorLocal != INVALID_HANDLE){
        CopyBuffer(manipuladorLocal, 0, 0, qtdPosCopiadas, MaxMes);
        CopyBuffer(manipuladorLocal, 1, 0, qtdPosCopiadas, MaxSem);
        CopyBuffer(manipuladorLocal, 2, 0, qtdPosCopiadas, MaxDia);
        CopyBuffer(manipuladorLocal, 3, 0, qtdPosCopiadas, Meio);
        CopyBuffer(manipuladorLocal, 4, 0, qtdPosCopiadas, MinDia);
        CopyBuffer(manipuladorLocal, 5, 0, qtdPosCopiadas, MinSem);
        CopyBuffer(manipuladorLocal, 6, 0, qtdPosCopiadas, MinMes);
    }else{
        Comment("CoCOkljasndjgasjdib");
    }
}

void NsVPR::updateBuffers(){
    updateBuffers(1);
}

double NsVPR::getBufferValue(int bufferEnum, int bufferPos){
    //Faz cast do valor inserido da relacao do buffer
    ENUM_NSVPR_BUFFERS bufferRetorno = (ENUM_NSVPR_BUFFERS) bufferEnum;
    //Atualiza os buffers
    this.updateBuffers(bufferPos);
    //Define o index de acesso no buffer e verifica se é valido
    int bufferAcess = bufferPos-1;
    if(bufferAcess > ArraySize(Meio) || bufferAcess < 0)
        return 0;
    switch (bufferRetorno){
    case NS_MAXM:
        return this.MaxMes[0];
        break;
    case NS_MAXS:
        return this.MaxSem[0];
        break;
    case NS_MAXD:
        return this.MaxDia[0];
        break;
    case NS_MID:
        return this.Meio[0];
        break;
    case NS_MIND:
        return this.MinDia[0];
        break;
    case NS_MINS:
        return this.MinSem[0];
        break;
    case NS_MINM:
        return this.MinMes[0];
        break;
    default:
        return 0;
        break;
    }
}

double NsVPR::getBufferLast(int bufferEnum){
    return getBufferValue(bufferEnum, 1);
}